﻿<%@ Page Language="vb" ValidateRequest="false" Debug="true" %>
<%@ Register TagPrefix="editor" Assembly="WYSIWYGEditor" namespace="InnovaStudio" %>

<script language="VB" runat="server">
    Sub Page_Load(Source As Object, E As EventArgs)
        
        If Not Page.IsPostBack Then
            oEdit1.Text = "Hello World!"
        End If
                
        '***************************************************
        '   SET THE EDITOR DIMENSION (WIDTH x HEIGHT)
        '***************************************************
            
        oEdit1.Width = 750
        oEdit1.Height=350
            

        '***************************************************
        '   ADD CUSTOM DIALOG TO OPEN YOUTUBE INSERT DIALOG (youtube.htm). This will replace the built-in youtube insert dialog.
        '***************************************************
        
        oEdit1.CustomDialogs.Add(New Param("YoutubeVideo", "modelessDialogShow('../common/youtube.htm',735,555)"))
        
        
        '***************************************************
        '   RECONFIGURE TOOLBAR BUTTONS
        '***************************************************
 
        Dim tabHome As InnovaStudio.ISTab
        Dim tabInsert As InnovaStudio.ISTab
        Dim grpEdit1 As InnovaStudio.ISGroup = New InnovaStudio.ISGroup("grpEdit1", "", New String() {"StyleAndFormatting", "Undo", "Redo", "Cut", "Copy", "Paste", "PasteWord", "PasteText", "BRK", "Bold", "Italic", "Underline", "ForeColor", "BackColor"})
        Dim grpEdit2 As InnovaStudio.ISGroup = New InnovaStudio.ISGroup("grpEdit2", "", New String() {"JustifyLeft", "JustifyCenter", "JustifyRight", "JustifyFull", "Paragraph", "BRK", "Numbering", "Bullets", "Indent", "Outdent", "Styles"})
        Dim grpEdit3 As InnovaStudio.ISGroup = New InnovaStudio.ISGroup("grpEdit3", "", New String() {"FontName", "FontSize", "BRK", "Strikethrough", "Superscript"})
        Dim grpEdit4 As InnovaStudio.ISGroup = New InnovaStudio.ISGroup("grpEdit4", "", New String() {"Search", "FullScreen", "BRK", "RemoveFormat", "XHTMLSource"}) '
        Dim grpEdit5 As InnovaStudio.ISGroup = New InnovaStudio.ISGroup("grpEdit5", "", New String() {"YoutubeVideo", "FlickrButton", "BRK", "Image"}) '
        Dim grpEdit6 As InnovaStudio.ISGroup = New InnovaStudio.ISGroup("grpEdit6", "", New String() {"Table", "AutoTable", "BRK", "Hyperlink", "Bookmark"})
        Dim grpEdit7 As InnovaStudio.ISGroup = New InnovaStudio.ISGroup("grpEdit7", "", New String() {"Characters", "Line", "BRK", "CustomTag"})

        
        '~~~~~ Without Tabbed ~~~~~
        oEdit1.ToolbarMode = 2

        tabHome = New InnovaStudio.ISTab("tabHome", "Home")
        tabHome.Groups.AddRange(New InnovaStudio.ISGroup() {grpEdit1, grpEdit2, grpEdit3, grpEdit5, grpEdit6, grpEdit7, grpEdit4})
        oEdit1.ToolbarTabs.Add(tabHome)
        '~~~~~ /Without Tabbed ~~~~~
        
        
        '~~~~~ Tabbed ~~~~~
        'oEdit1.ToolbarMode = 1

        'tabHome = New InnovaStudio.ISTab("tabHome", "Home")
        'tabHome.Groups.AddRange(New InnovaStudio.ISGroup() {grpEdit1, grpEdit2, grpEdit3, grpEdit4})
        'oEdit1.ToolbarTabs.Add(tabHome)

        'tabInsert = New InnovaStudio.ISTab("tabInsert", "Insert")
        'tabInsert.Groups.AddRange(New InnovaStudio.ISGroup() {grpEdit5, grpEdit6, grpEdit7})
        'oEdit1.ToolbarTabs.Add(tabInsert)
        '~~~~~ /Tabbed ~~~~~
              
            
        '***************************************************
        '   OTHER SETTINGS
        '***************************************************
            
        oEdit1.Css="style/test.css" 'Specify external css file here

        oEdit1.CustomTags.add(new Param("First Name","{%first_name%}"))
        oEdit1.CustomTags.add(new Param("Last Name","{%last_name%}"))
        oEdit1.CustomTags.add(new Param("Email","{%email%}"))

        oEdit1.CustomColors = New String() {"#ff4500","#ffa500","#808000","#4682b4","#1e90ff","#9400d3","#ff1493","#a9a9a9"}

        oEdit1.EditMode = EditorModeEnum.XHTMLBody

    End Sub

    Sub Button1_Click(Source As System.Object, E As System.EventArgs)
        Label1.Text = oEdit1.Text
    End Sub
</script>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <style>
        body{font:11px verdana,arial,sans-serif;}
        a{color:#0000cc;font-size:xx-small;}
    </style>
</head>
<body>
   
<form id="Form1" method="post" runat="server">

    <h2>Insert Youtube Video</h2>

    <div style="margin-top:30px;margin-bottom:30px;">
    <asp:label id="Label1" runat="server"/>
    </div>
    <div style="clear:both;"></div>

    <h3>IMPLEMENTATION</h3>
    <p>   
    <b>STEP 1</b>: Add custom dialog to open youtube.htm:<br />
    <pre>
        oEdit1.CustomDialogs.Add(New Param("YoutubeVideo", "modelessDialogShow('../common/youtube.htm',735,555)"))
    </pre>
    youtube.htm is a Custom Dialog that we use to insert Youtube video. With the above command, the dialog (youtube.htm) will be opened when a user clicks the "YoutubeVideo" button.
    <br /><br /><br />
    <b>STEP 2</b>: Include the "YoutubeVideo" Button in the Editor configuration:<br />
    <pre>
        Dim tabHome As InnovaStudio.ISTab
        Dim tabInsert As InnovaStudio.ISTab
        Dim grpEdit1 As InnovaStudio.ISGroup = New InnovaStudio.ISGroup("grpEdit1", "", New String() {"StyleAndFormatting", "Undo", "Redo", "Cut", "Copy", "Paste", "PasteWord", "PasteText", "BRK", "Bold", "Italic", "Underline", "ForeColor", "BackColor"})
        Dim grpEdit2 As InnovaStudio.ISGroup = New InnovaStudio.ISGroup("grpEdit2", "", New String() {"JustifyLeft", "JustifyCenter", "JustifyRight", "JustifyFull", "Paragraph", "BRK", "Numbering", "Bullets", "Indent", "Outdent", "Styles"})
        Dim grpEdit3 As InnovaStudio.ISGroup = New InnovaStudio.ISGroup("grpEdit3", "", New String() {"FontName", "FontSize", "BRK", "Strikethrough", "Superscript"})
        Dim grpEdit4 As InnovaStudio.ISGroup = New InnovaStudio.ISGroup("grpEdit4", "", New String() {"Search", "FullScreen", "BRK", "RemoveFormat", "XHTMLSource"}) 
        Dim grpEdit5 As InnovaStudio.ISGroup = New InnovaStudio.ISGroup("grpEdit5", "", New String() {"YoutubeVideo", "BRK", "Image"})
        Dim grpEdit6 As InnovaStudio.ISGroup = New InnovaStudio.ISGroup("grpEdit6", "", New String() {"Table", "AutoTable", "BRK", "Hyperlink", "Bookmark"})
        Dim grpEdit7 As InnovaStudio.ISGroup = New InnovaStudio.ISGroup("grpEdit7", "", New String() {"Characters", "Line", "BRK", "CustomTag"})
    </pre>
    </p>

    <h3>DEMO</h3>

    <editor:wysiwygeditor 
        Runat="server"
        scriptPath="../scripts/"
        ID="oEdit1" />
        
    <asp:button runat="server" onclick="Button1_Click" Text="SUBMIT" ID="btnSubmit" />

</form>

</body>
</html>