<?

//***********************************************************************************************//
// CLASS myDIR
//***********************************************************************************************//

/*
 * INFO:
 *     this script reads a specified dir and
 *     return a array with $folder $file $size $time
 *     needs PHP4 or higher
 *
 * AUTHOR & COPYRIGHT (C):
 *     alexander klein
 *     http://www.alexanderklein.de
 *     mail@alexanderklein.de
 *
 * RELEASE:
 *     version 1.1 (24-02-2002)
 *
 * THANKS TO CARLOS FOR THE OPTION TO INCLUDE MORE THAN ONE EXTENSION.
 *     carlos pires
       http://www.osbrasil.org
 *
 * USAGE:
 *
 **************************************************************************************************

 require("./class.dir.php");

 $DIR = new myDIR;

 $DIR->setMASK("*.php,*.html,*.txt"); // ("*.html,*.htm,*.txt") separated with comma
 $DIR->setFIND("files");              // could be "folder" "files" "all"
 $DIR->setROOT("./phpMyAdmin");       // start folder

 $RESULT = $DIR->getRESULT();

 echo "<table cellpadding='5' cellspacing='5'>\n";
 echo "<tr><td colspan='4'>Found ".count($RESULT)."</td></tr>\n";
 for ( $i=0 ; $i < count($RESULT); $i++ )
 {
     $bgcolor = ( $i%2 == 0 ) ? "#DDDDDD" : "#EFEFEF";

     echo "<tr bgcolor='$bgcolor'>";
     echo "<td>&nbsp;".$RESULT[$i]["folder"]."</td>";
     echo "<td>&nbsp;".$RESULT[$i]["file"]."</td>";
     echo "<td>&nbsp;".$RESULT[$i]["size"]."</td>";
     if ($RESULT[$i]["time"])
     {
         echo "<td>".strftime("%d.%m.%y - %H:%M",$RESULT[$i]["time"])."</td>";
     }
     else
     {
         echo "<td>&nbsp;</td>";
     }
     echo "</tr>\n";
 }
 echo "</table>\n";

 **************************************************************************************************
 *
 * CHANGELOG
 *
 * 24.02.2002 - added natcasesort
 *            - added option to include more than on extension
 *
 **************************************************************************************************
 *
 */

class myDIR
{

    var $mask   = "";
    var $find   = "";
    var $root   = array();
    var $temp   = array();
    var $result = array();

     //** setFIND ********************************************************************************//

    function setFIND($val)
    {
        $this->find = $val;
    }

    //** setMASK ********************************************************************************//

    function setMASK($val="")
    {
        $this->mask = $val;
    }

    //** setROOT ********************************************************************************//

    function setROOT($val="")
    {
        $this->root[] = $val;
    }

    //********************************************************************************************//

    //** setARRAY ********************************************************************************//

    function setARRAY($folder="",$file="",$size="",$time="")
    {
        $this->result[] = array("folder"=>$folder,"file"=>$file,"size"=>$size,"time"=>$time);
    }

    //** doSEARCH ********************************************************************************//

    function doSEARCH()
    {
        for($i=0; $i<count($this->root); $i++)
        {
            unset($this->temp);

            $handle = @opendir($this->root[$i]);
            while ($file = @readdir ($handle))
            {
                if (preg_match("/^\.{1,2}$/i",$file))
                {
                    continue;
                }
                $this->temp[] = $this->root[$i]."/$file";
            }
            @closedir($handle);

            if (count($this->temp) > 0)
            {
                natcasesort($this->temp);

                foreach ($this->temp as $val)
                {
                    switch ($this->find)
                    {
                    	case "folder":
                    	    $this->doFOLDER($val);
                    	break;
                    	case "files":
                    	    $this->doFILES($val);
                    	break;
                    	case "all":
                    	    $this->doFILES($val);
                    	    $this->doFOLDER($val);
                    	break;
                    }
                }
            }
        }
    }

    //** doFOLDER ********************************************************************************//

    function doFOLDER($val)
    {
        if( is_dir($val) )
        {
            if ($this->find == "all")
            {
                $this->root[] = $val;
            }
        }
    }

    //** doFILES ********************************************************************************//

    function doFILES($val)
    {
        if( is_file($val) && $this->doMATCH($val) )
        {
            $this->doINFO($val);
        }
    }

    //** doINFO *********************************************************************************//

    function doINFO($val)
    {
        $fSIZE = filesize($val);
        $fTIME = filemtime($val);

        $offset = strrpos ($val, "/");
        $folder = substr ($val, 0, $offset);
        $file   = substr ($val, $offset+1);

        $this->setARRAY($folder,$file,$fSIZE,$fTIME);
    }

    //** getRESULT ********************************************************************************//

    function doMATCH($file)
    {
    	$mask = $this->mask;
        $mask = str_replace(".", "\.", $mask);
        $mask = str_replace("*", "(.*)", $mask);

        $mask_array = explode(',',$mask);
        foreach ($mask_array as $valid)
        {
            if(preg_match("/^$valid/i", $file))
            {
                return true;
            }
        }
    }

    //** getRESULT ********************************************************************************//

    function getRESULT()
    {

        $version = strtok (phpversion(),'.');
        if ( $version < 4 )
        {
            echo "ERROR: phpMyAdmin does only works with PHP-Versions 4.0 or higher.\n<br>";
            echo "Your Version is (".phpversion().").";
            exit;
        }









        $this->doSEARCH();

//    	if ( !$this->result )
//    	{
//    	    echo "ERROR: No Data or Folder does not exist (".$this->root.")";
//    	    exit;
//    	}

        return $this->result;

    }

    //*******************************************************************************************//

}

//***********************************************************************************************//

?>