<?php
/*
 * API operation getPaymentInstruction
 *
 * In the case of orders handled via BillSAFE, the customer no longer makes payment
 * directly to you but to BillSAFE instead. For this reason, it is important that you provide your
 * customer with an invoice containing the precise payment modalities. Using operation
 * getPaymentInstruction, you can request all the details required for the payment in
 * structured form, for instance in order to include them on your invoice. Alternatively, you can
 * download a PDF made available by BillSAFE via this operation, which you can then print
 * out as an insert to enclose with your delivery. Should you wish to request the payment
 * details for an impending part delivery, you can specify the articles involved. Subsequently,
 * operation reportShipment should be performed with the same article list once the
 * shipment has been effected.
 */

//The following array contains the names of all possible request parameters (except articleList,
//see below) that can/must be specified with the API operation prepareOrder

include("Billsafe/params.php");
if (isset($billsafe_transactionID)) {
	$params["transactionId"] = $billsafe_transactionID;
} else if ($Kunde->Value("billsafe_transactionID") != "") {
	$params["transactionId"] = $Kunde->Value("billsafe_transactionID");
}

//call Sdk method 'callMethod' with parameters method name and all other parameters (array)
$response = $bs->callMethod('getPaymentInstruction', $params);

//The response always includes element "ack" (= acknowledgment / receipt confirmation),
//which can assume value "OK" or "ERROR".
//- "OK" means that the operation has been executed successfully. Depending on the
//  operation, the response will include further elements.
//- "ERROR" means that the operation could not be executed. In that case, the
//  response will include element "errorList" with one or several error elements
if ($response->ack == 'OK')
{
    //available if outputType = STRUCTURED
    if (isset($response->instruction))
    {
		$SQL_zusatz = fixHTMLquotes($response->instruction->legalNote)."

Bitte überweisen Sie den ausstehenden Betrag bis zum ".date("d.m.Y",time()+$response->instruction->paymentPeriod*86400)."

Empfänger: ".fixHTMLquotes($response->instruction->recipient)."
Kontonr.:  ".fixHTMLquotes($response->instruction->accountNumber)."
BLZ:       ".fixHTMLquotes($response->instruction->bankCode)."
Bank:      ".fixHTMLquotes($response->instruction->bankName)."
BIC:       ".fixHTMLquotes($response->instruction->bic)."
IBAN:      ".fixHTMLquotes($response->instruction->iban)."
Betrag:    ".fixHTMLquotes($response->instruction->amount)." ".fixHTMLquotes($response->instruction->currencyCode)."
Verwendungszweck 1: BTN ".fixHTMLquotes($response->instruction->reference)."
Verwendungszweck 2: ".$host."

".fixHTMLquotes($response->instruction->legalNote);
		
//		echo '<div id="fehler">'.nl2br($SQL_zusatz).'</div><br />';
		
		mysql_query ("UPDATE `wk_kunden` SET zusatz_rech = '".$SQL_zusatz."' where aiyootaID = '".$aiyootaID."' and warenkorbID = '" . $wmxKundenID . "';");
		echo mysql_error();
    }
//     else
//     {
//         //Base 64 encoded content of PDF insert. Only available if outputType = PDF
//         $data = base64_decode($response->data);
// 
//         header('Content-type: application/pdf');
//         header('Content-Disposition: attachment; filename="paymentInstruction.pdf"');
// 
//         echo $data;
//     }
}
else
{
    //If an operation could not be executed successfully, the "ack" element included in the
    //response will contain the value "ERROR". In addition, one or several error messages
    //consisting of an error code and an error description will be output.
    ?>
    <span class="error">The following errors have occured:</span><br/>
    <ul>
    <?php

    $errors = $response->errorList;

    foreach ($errors as $error)
    {
        //Error codes consist of a three-digit numerical value. See BillSAFE Integration Guide
        //for a list of the most important error codes.
        echo '<li>' . $error->code . ' - ' . $error->message . '</li><br/>';
    }
    echo '</ul>';
}
?>