<?php

/*
*	
*	PopPhoto 2.3
*	Copyright 2002 - 2004 Jamie Longstaff
*	
*	Script author:		Jamie Longstaff
*	Script version:		2.3	
*
*/


/*
*	
*	mixed popc_clear_cache()
*	
*	Deletes all the Smarty template cache files
*
*/

function popc_clear_cache() {

	global $cfg;
	
	// Delete the contents of the Smarty templates_c and caches directory
	$handle=@opendir($cfg['POPCARD_ROOT']."resources/smarty/templates_c/");
	$fn=0;
	if($handle != FALSE) {
	
		while (false!==($file = readdir($handle))) { 
		
			if (substr($file,0,1) != ".") { 
			
			@unlink($cfg['POPCARD_ROOT']."resources/smarty/templates_c/".$file);
			
			}
		}
	}

	@closedir($handle);
	
}


/*
*	
*	mixed popc_calc_width(int width, [[int factor], [int deductor]])
*	
*	order should be asc or desc.
*	
*	Returns FALSE if SQL fails or no rows found or bad argument count, otherwise Returns Multidimentional Array.
*	
*	First Dimension uses numerical keys with offset 0 each representing a table row.
*	
*	Second Dimension is the row as Column Name key and Column Value value.
*
*/

function popc_calc_width($factor="",$deductor="") {

	global $cfg;
	
	$numarg = func_num_args();

	switch($numarg) {

		case '2':
			$width = ( floor($cfg['POPCARD_WIDTH'] / $factor) - $deductor);
			break;
		case '1':
			$width = ( floor($cfg['POPCARD_WIDTH'] / $factor) - 1);
			break;
		default:
			$width = $cfg['POPCARD_WIDTH'];
			break;
	}
	
	return $width;


}

/*
*	
*	popc_email_check -- Check an e-mail address is formatted corrrectly
*	
*	string  popc_email_check(string email)
*	
*	If email matches correct valid e-mail address return FALSE
*	
*	if email does NOT match correct valid e-mail address return FALSE
*
*/

function popc_email_check($email) {

	if (preg_match("/[A-Z0-9._%-]+@[A-Z0-9._%-]+\.[A-Z]{1,4}/",$email)) {
	return TRUE;
	} else {
	return FALSE;
	}

}

/*
*	
*
*/


function popc_sendemail() {

global $cfg, $lang, $name, $email, $recipient, $imagedata;

$filename = time();

//	 Create a mail message and send it to the recipient
mail($recipient, "$name " . $lang['pcm_sender_sent'] . "!", "",
"From: \"$name\" <$email>
Reply-To: \"$name\" <$email>
X-Accept-Language: en-us, en
MIME-Version: 1.0
Content-Type: multipart/alternative;
 boundary=\"------------020901080506000807040501\"
Status:   



This is a multi-part message in MIME format.
--------------020901080506000807040501
Content-Type: text/plain; charset=us-ascii; format=flowed
Content-Transfer-Encoding: 7bit

PopCard Greetings E-mail Greetings Card

--------------020901080506000807040501
Content-Type: multipart/related;
 boundary=\"------------060004020903050504090102\"


--------------060004020903050504090102
Content-Type: text/html; charset=us-ascii
Content-Transfer-Encoding: 7bit

<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">
<html>
<head>
  <meta content=\"text/html;charset=ISO-8859-1\" http-equiv=\"Content-Type\">
  <title></title>
</head>
<body bgcolor=\"#ffffff\" text=\"#000000\">

<img src=\"cid:part1.$filename.02090003@popsoft.info\" border=\"0\"><br><br>
<font face=\"verdana,helvetica,geneva\" size=\"3\">
".$cfg['email_link']."
</font>
</body>
</html>

--------------060004020903050504090102
Content-Type: image/jpeg;
 name=\"popcard$filename.jpg\"
Content-Transfer-Encoding: base64
Content-ID: <part1.$filename.02090003@popsoft.info>
Content-Disposition: inline;
 filename=\"popcard.jpg\"

$imagedata

--------------060004020903050504090102--

--------------020901080506000807040501--
");

}

/*
*	
*
*/

function popc_loadjpeg_mod($pu) {

global $cfg;

$handle = fopen ($pu, "rb");
$contents = "";
do {
    $data = fread($handle, 200000);
    if (strlen($data) == 0) {
        break;
    }
    $contents .= $data;
} while(true);
fclose ($handle);


//	-- Create a temporary file on disk --*	
$time = time();

//	-- Put image data into the temp file --*	
$fp = fopen($cfg['temporary'] . $time, "w");
fwrite($fp,$contents);
fclose($fp);

//	-- Load Image from Disk with GD library --*	
$im = imagecreatefromjpeg ($cfg['temporary'] . $time);

//	-- Delete Temporary File --*	
unlink($cfg['temporary'] . $time);

//	-- Check for errors --*	
if (!$im) {
print "Could not create JPEG image $pu";
}

return $im;
}

/*
*	
*
*/

function popc_output_image($font_name,$imagefile,$postcard_text,$quality,$respath,$outmet) {

//	 Get the values for GD2 and the URL into this function
global $cfg, $pu;

$GD2		= $cfg['GD2'];
$quality	= $cfg['quality'];

// Path to the fonts directory
$fontfile = $respath . "/fonts/$font_name";

// The source image file path
$theimage = $respath . "/images/" . $imagefile;

if ($pu) {

// Create an image resource with the source photo
$src_img = popc_loadjpeg_mod($pu);

} else {

// Create an image resource with the source photo
$src_img = ImageCreateFromJPEG($theimage);

}

// width original image
$src_width = imagesx($src_img); 

// height original image
$src_height = imagesy($src_img); 

//	 Insert code to find image aspect ratio
if (($src_width / $src_height) > 0.85) {

$port		= "FALSE";
$template	= "/media/template.01.jpg";
$blank		= "/media/blank.01.jpg";
$imghgt		= "310";
$imgwdt		= "618";

} else {

$port		= "TRUE";
$template	= "/media/template.02.jpg";
$blank		= "/media/blank.01.jpg";
$imghgt		= "398";
$imgwdt		= "578";

}

// reduction ratio
$rr = $imghgt / $src_height; 

// New image width
$new_width = $rr * $src_width; 

// Check the version of GD set in the preferences
if ($GD2 == "TRUE") {

// Create a blank image space for the resized image 
$dest_img = imagecreatetruecolor($new_width,$imghgt); 

// Open the template file and create an image resource with it
$template = imagecreatefromjpeg($respath . $template);

// Resize the source picture to fit into the bounds of the template
imagecopyresampled($dest_img, $src_img, 0, 0, 0 ,0, $new_width, $imghgt, $src_width, $src_height);

} else {

// Create a blank image space for the resized image 
$dest_img = imagecreatefromjpeg($respath . $blank); 

// Open the template file and create an image resource with it
$template = imagecreatefromjpeg($respath . $template);

// Resize the source picture to fit into the bounds of the template
imagecopyresized($dest_img, $src_img, 0, 0, 0 ,0, $new_width, $imghgt, $src_width, $src_height);

}

// Copy the source image into the template image leaving a 1 pixel margin at the sides for the black border
imagecopy ($template, $dest_img, 1, 1, 0, 0, $new_width, $imghgt);

// Only continue of there is message text to work with.
if ($postcard_text) {

	// Set font sizes for each specific font family
	if 		($font_name == "briquetn.ttf") { $size = "13"; }
	elseif 	($font_name == "arialbd.ttf") { $size = "11"; }
	elseif 	($font_name == "comicbd.ttf") { $size = "10"; }

	// Set the total with of the text box
	$width = $imgwdt - $new_width - 20;
	
	// Break the message text into words
	$ex = explode(" ", stripslashes(stripslashes(urldecode($postcard_text))));
	
	// Count the number of words
	$ex_c = count($ex);
	
	$p = 0; 
	$i = 0;
	
	// Split the text into lines of words that will fit into the space on the right of the card
	for ($i=0; $i<$ex_c; $i++) {
	
		 $test = $full[$p] . " "; 
		 $test .= $ex[$i];
		 $bbox = imagettfbbox($size, 0, $fontfile, $test); 
	
		if(($bbox[4] - $bbox[6]) > $width) { 
		  $p++; 
		  $full[$p] = $ex[$i]; 
		 } else {
		  $full[$p] = $test; 
		}
	
	}
	
	for ($k=0; $k < count($full); $k++) {
		$line = each($full);
		$output .= $line[value] . "\r\n";
	}
	
	// Knock out the leading whitespace
	$output = substr($output, 1);  
	
	if ($port == "TRUE") {
	
		// Create an image
		$im = imagecreate($width,300);
		
	} else {
	
		// Create an image
		$im = imagecreate($width,247);
		
	}
	
	// Assign the image white colour space (background colour)
	$white = imagecolorallocate($im, 255,255,255);
	
	// Assign the image black colour space (text colour)
	$black = imagecolorallocate($im, 0,0,0);
	
	// Distance in pixels to place the text box from the left edge of the template
	$im_position = $new_width + 10;
	
	// Distance in pixels to place the text box from the top edge of the template
	$top_offset = "60";
	
	// Write the text into our blank image as anti-aliased text.
	imagettftext($im, $size, 0, 0, 20, $black, $fontfile ,$output);
	
	if ($port == "TRUE") {
	
	// Copy the text image into our template positioning it correctly in the box.
	imagecopy ($template, $im, $im_position, $top_offset, 0, 0, $width, 300); 
		
	} else {
	
	// Copy the text image into our template positioning it correctly in the box.
	imagecopy ($template, $im, $im_position, $top_offset, 0, 0, $width, 247); 
		
	}

}

// Select the correct mode in which to send the image data

if ($outmet == "BASE64") {

	$this_image = time();
	
	$this_image_loc = $cfg[temporary] . $this_image;
	
	imagejpeg($template, $this_image_loc, $cfg['quality']);
	$handle = fopen($this_image_loc,'rb'); 
	$file_content = fread($handle,filesize($this_image_loc)); 
	fclose($handle); 
	$encoded = chunk_split(base64_encode($file_content)); 
					
	unlink($this_image_loc);
	
	return ($encoded);

} elseif ($outmet == "IMAGE") {

	return(imagejpeg($template, '', $quality));
	
}

	imagedestroy($im); 
	imagedestroy($src_img); 
	imagedestroy($template); 
	imagedestroy($dest_img);				
	


}

/*
*	
*	apost -- $_POST array scan for specified key.
*	
*	string  apost(string key)
*	
*	If key matches key in $_POST array, Returns string which is value of key from $_POST array 
*	
*	if key does NOT match key in $_POST array, Returns EMPTY STRING.
*
*/

function apost($name){

	foreach($_POST as $key=>$value){

		if($name == $key){if($value !== ''){$output = $value;}}
	}

	if(!isset($output)){$output = '';}

$output = strip_tags(substr(trim($output),0,500));

return($output);

}

/*
*	
*	acookie -- $_COOKIE array scan for specified key.
*	
*	string  apost(string key)
*	
*	If key matches key in $_COOKIE array, Returns string which is value of key from $_COOKIE array 
*	
*	if key does NOT match key in $_COOKIE array, Returns EMPTY STRING.
*
*/

function acookie($name){

	foreach($_COOKIE as $key=>$value){

		if($name == $key){if($value !== ''){$output = $value;}}
	}

	if(!isset($output)){$output = '';}

return($output);

}

/*
*	
*	aget -- $_GET array scan for specified key.
*	
*	string  aget(string key)
*	
*	If key matches key in $_GET array, Returns string which is value of key from $_GET array 
*	
*	if key does NOT match key in $_POST array, Returns EMPTY STRING.
*
*/

function aget($name){

	foreach($_GET as $key=>$value){

		if($name == $key){if($value !== ''){$output = $value;}}
	}

	if(!isset($output)){$output = '';}
	
	
$output = strip_tags(substr(trim($output),0,500));

return($output);

}

/*
*	
*	aglobal -- $_POST and $_GET array scan for specified key.
*	
*	string  aglocal(string key)
*	
*	If key matches key in $_POST or $_GET array, Returns string which is value of key from $_POST or $_GET array.
*	
*	if key does NOT match key in $_POST or $_GET array, Returns EMPTY STRING.
*	
*	by order of execution, precedence is given to $_POST.
*
*/


function aglobal($name){

	foreach($_GET as $key=>$value){

		if($name == $key){if($value !== ''){$output = $value;}}
	}

	foreach($_POST as $key=>$value){

		if($name == $key){if($value !== ''){$output = $value;}}
	}

	if(!isset($output)){$output = '';}

$output = strip_tags(substr(trim($output),0,500));

return($output);

}


?>