<?php 

#################################################################
##
##	PopPhoto 3.2
##	Copyright 2002 - 2004 Jamie Longstaff
##
##	Script author:		Jamie Longstaff
##	Script version:		3.2	
##
#################################################################

#################################################################
##
##  Takes an array and moves the value of the key specified by $item_val
##  either up or down through the array depending on the value of $item_act

function pops_array_shift_key($pri_array,$item_val,$item_act) {

	$item_key = array_search($item_val,$pri_array);
	
	if ($item_act == "u" && ($item_key+1 <= count($pri_array))) {
	
		$repl_key = $item_key + 1;
		$repl_val = $pri_array[$repl_key];
		
		array_splice($pri_array,$repl_key,1,$item_val);
		array_splice($pri_array,$item_key,1,$repl_val);
	
	} elseif ($item_act == "d" && ($item_key-1 >= 0)) {
	
		$repl_key = $item_key - 1;
		$repl_val = $pri_array[$repl_key];
		
		array_splice($pri_array,$repl_key,1,$item_val);
		array_splice($pri_array,$item_key,1,$repl_val);
	
	}
	
	return($pri_array);

}

##
##
#################################################################
##
##  Convert a numeric decimal string into a two sig fig decimal string
##	e.g. 120.0 -> 120.00

function pops_sig_fig($var) {

	$var = round($var,2);
	
	list ($base,$decimal) = split('[/.-]', $var);
	
	$newvar = $base . "." . str_pad($decimal, 2, "0", STR_PAD_RIGHT);
	
	return($newvar);

}

##
##
#################################################################
##
##  Take a sentence or group of words and trim to a certain word length with closing ellipis (...)
##
##	$string (string) The string to truncate
##	$length (int) The number of words to include

function pops_trim_words($string,$length) {

	$words = explode(" ",$string);
	
	if (count($words) >= $length) {
	
		$trimmed = "";
				
		for ($i = 0; $i < $length; $i++) {
		
		$trimmed .= $words[$i]." ";
		
		}
		
		$trimmed = rtrim($trimmed," \t\n\r.,()!;:?'-");
		
		$trimmed .= "...";
		
		return($trimmed);
	
	} else {
	
		return($string);
	
	}
}

##
##
#################################################################
##
##  mixed pops_trim_ellipsis([[string string], [int length]])
##
##  Returns the input variable string trimmed to length and with a trailing ellipsis
##	if the string length is greater than the input length value
##

function pops_trim_ellipsis($string,$length) {

	if (strlen($string) >= $length) {
	$string = substr($string,0,$length) . "...";
	}
	
	return $string;

}

##
##
#################################################################
##
##  Function to send an e-mail to a user

function pops_sendemail($toemail, $toname, $message, $fromemail, $fromname, $subject) {

	global $cfg;
	if (!preg_macht("/.loc/",$_SERVER['SERVER_NAME'])) {
	
		if ($toname !== '') {
		
		$to = "\"".$toname."\" <".$toemail.">";
		
		} else {
		
		$to = "<".$toemail.">";
		
		}
	
		$replyto = "<".$fromemail.">";
	
		if ($fromname !== '') {
		
		$headers = "From: \"".$fromname."\" <".$fromemail.">\r\n";
		
		} else {
		
		$headers = "From: $fromemail\r\n";
		
		}
	
		$subject = stripslashes($subject);
	
		$message = stripslashes($message);
	
		$headers .= "X-Mailer: PHP/" . phpversion() . "\r\n"; 
	
		$headers .= "MIME-Version: 1.0\r\n";
	
		$headers .= "Reply-To: $replyto\r\n";
	
		if (!@mail($to, $subject, $message, $headers, "-f $fromemail")) {
		
			return(FALSE);
		
		} else {
		
			return(TRUE);
		
		}
		
	}
	
}

##
##
#################################################################
##
##  Input two variables (Windows or MacOS) and return one depending on user platform.

function pops_platform_swap($winvalue,$macvalue) {
	
		if ($_SERVER['$TRANSFER_AGENT']) {
		$agent = $_SERVER['$TRANSFER_AGENT'];
		} else {
		$agent = $_SERVER['HTTP_USER_AGENT'];
		}
		
	$Browser_Name = strtok($agent, "/");  
	$Browser_Version = strtok("  ");  

	if (preg_match("/MSIE/", $agent)) {  
		$Browser_Name = "MSIE";  
		$Browser_Version = strtok("MSIE");  
		$Browser_Version = strtok("  ");  
		$Browser_Version = strtok(";");  
	}  

	$Browser_Platform = "unknown";  
	if (preg_match("/Win/", $agent)) {  
		$Browser_Platform = "Windows";
		return $winvalue;
	} else {
		if (preg_match("/Mac/", $agent)) {  
			$Browser_Platform = "Macintosh"; 
			return $macvalue;
		} else {
			return $winvalue;
		}
	}  
}


##
##
#################################################################
##
##  Detects if the browser is IE and returns $expvalue if it is.

function pops_browser_swap($expvalue,$othvalue) {

		if ($_SERVER['$TRANSFER_AGENT']) {
		$agent = $_SERVER['$TRANSFER_AGENT'];
		} else {
		$agent = $_SERVER['HTTP_USER_AGENT'];
		}

	if (preg_match("/MSIE/", $agent)) {  
		return $expvalue;
	} else {
		return $othvalue;
	} 
}

##
##
#################################################################

?>